/*
               IdiotPaint
       The Paint Program For Morons
          Written by Brian Gaeke
          1992-1996 Brian Gaeke
       All rights reserved worldwide.
             Version: 1.1
*/

/* VersionHistory:
   1.0 -- First semi-public release. It sat in a folder on CX 7 in the CX lab until
   somebody deleted it. It ran pretty much OK, except for that when you did a
   'Blend' it would sometimes draw over the pseudo-scroll-bar region. Still haven't
   fixed the problem where Funky!'s DrawChar option would draw over the
   pseudo-scroll-bar region. Maybe later. But I have to have something to show for
   this.
   1.0.1 -- Changed Blend code to continually subtract i from the red value
   as i reaches gWindow->portRect.right. It makes a neater looking blend anyhow.
   David Winkler gave me a code fragment to implement real blends but I have to
   finish my homework so I won't be getting to that tonight. Still haven't fixed
   the DrawChar problem. FOO!
   1.0.2 -- Changed About box to be a little less insulting. Changed Color menu to
   include more colors. Added New and Close, and changed close-box in window to call
   Close instead of quitting; it's more HIG-ly that way. Still waiting on blend code.
   DrawChar problem fixed. Will probably release this soon.
   1.1: MacHack release
*/

/* IdiotPaintPPC_CW9.c */

#include "IdiotPaintPPC_CW9.h"
#include "IdiotPaintPPC_CW9.proto.h"

Boolean InBackground(void)
{
	PSN aPsn, bPsn;
	Boolean same;
	OSErr err;
	
	err = GetCurrentProcess(&aPsn);
	err = GetFrontProcess(&bPsn);
	err = SameProcess(&aPsn,&bPsn,&same);
	return same;
}

void EraseGWorld(GWorldPtr it)
{
	GDHandle gd;
	CGrafPtr cp;
	
	GetGWorld(&cp,&gd);
	SetGWorld(it,NULL);
	EraseRect(&it->portRect);
	SetGWorld(cp,gd);
}

void FatalError(short number, short id)
{
	Str255 str, str2;
	short ignored;

	GetIndString(str,ERRSTR_ID,number);
	NumToString(id,str2);
	ParamText(str,"\p Error ID# =",str2,"\p");
	ignored = Alert(errorAlrt,NULL);
	ExitToShell();
}

void UnexpectedError(short number)
{
	Str255 str,nstr;
	short ignored;
	
	NumToString((long) number,nstr);
	GetIndString(str,ERRSTR_ID,number);
	ParamText(str,"\p","\p",nstr);
	ignored = Alert(errorAlrt,NULL);
	ExitToShell();
}

void SetBW(Boolean onoff)
{
	static RGBColor savedFore, savedBack;
	static const RGBColor rgbWhite = {0xFFFF,0xFFFF,0xFFFF};
	static const RGBColor rgbBlack = {0x0000,0x0000,0x0000};
	
	if (onoff) {
		GetForeColor(&savedFore);
		GetBackColor(&savedBack);
		RGBForeColor(&rgbBlack);
		RGBBackColor(&rgbWhite);
	} else {
		RGBForeColor(&savedFore);
		RGBBackColor(&savedBack);
	}
}

void WindToOffscreen(void)
{
	Rect aRect;

	SetBW(TRUE);
	EraseGWorld(gOffscreen);
	SetRect(&aRect,0,0,gWindow->portRect.right - 15,gWindow->portRect.bottom - 15);
	CopyBits((BitMapPtr)*(gWindow->portPixMap),
		(BitMapPtr)*(GetGWorldPixMap(gOffscreen)),
		&aRect,&aRect,srcCopy,NULL);
	SetBW(FALSE);
}

void OffscreenToWind(void)
{
	Rect aRect;
	CGrafPtr thePort;
	
	SetBW(TRUE);
	gWindow->portRect.bottom -= 15;
	gWindow->portRect.right -= 15;
	GetPort((GrafPtr *)&thePort);
	SetPort((WindowPtr)gWindow);
	EraseRect(&gWindow->portRect);
	SetPort((WindowPtr)thePort);
	gWindow->portRect.bottom += 15;
	gWindow->portRect.right += 15;
	SetRect(&aRect,0,0,gWindow->portRect.right - 15,gWindow->portRect.bottom - 15);
	CopyBits((BitMapPtr)*(GetGWorldPixMap(gOffscreen)),
		(BitMapPtr)*(gWindow->portPixMap),
		&aRect,&aRect,srcCopy,NULL);
	SetBW(FALSE);
}

void InitMac(void)
{
	short x;
	
	InitGraf(&qd.thePort);
	InitFonts();
	FlushEvents(everyEvent,0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(NULL);
	InitCursor();
	MaxApplZone();
	for(x=1;x<11;x++)
		MoreMasters();
}

/* post a read/write failure alrt */
void PictIOErr(const unsigned char *errdescr, OSErr err)
{
	Str255 str;
	
	NumToString(err,str);
	ParamText(errdescr, str, "\p", "\p");
	(void)Alert(pictRdWrAlrt,NULL);
}

/* post a general failure alrt */
void GenericErr(const unsigned char *errdescr, OSErr err)
{
	Str255 str;
	
	NumToString(err,str);
	ParamText(errdescr, str, "\p", "\p");
	(void)Alert(genericErrAlrt,NULL);
}

pascal void ReadPictData(Ptr dataPtr, short byteCount)
{
	long theCount = byteCount;
	OSErr err;
	
	if ((err = FSRead(gPictFileRefNum,&theCount,dataPtr)) != noErr)
		PictIOErr("\preading",err);
}

void Initialize(void)
{
	Handle aMenubar;
	OSErr err;
	
	InitMac();
	
	gWindow = (CWindowPtr)GetNewCWindow(WINDOW_ID,NULL,FRONT);
	if (MemError()) err = MemError(); else err = ResError();
	if (!gWindow) FatalError(couldntGetWindow,err);
	((WindowPeek)gWindow)->refCon = OUR_WINDOW;
	
	SetPort((WindowPtr)gWindow);
	ZoomWindow((WindowPtr)gWindow, inZoomOut, false);
	gMaxWinSize = gWindow->portRect;
	gMaxSizeLoc.h = gWindow->portRect.left;
	gMaxSizeLoc.v = gWindow->portRect.top;
	LocalToGlobal(&gMaxSizeLoc);
	SetPort((WindowPtr)gWindow);
	ZoomWindow((WindowPtr)gWindow, inZoomIn, false);

	ShowWindow((WindowPtr)gWindow);
	
	aMenubar = GetNewMBar(MBAR_ID);
	if (MemError()) err = MemError(); else err = ResError();
	if (!aMenubar) FatalError(couldntGetMenuBar,err);
	SetMenuBar(aMenubar);
	DisposHandle(aMenubar);
	AddResMenu(GetMHandle(mApple),'DRVR');

	DrawMenuBar();
	
	gDone = false;
	gInBackgnd = InBackground();
	err = NewGWorld(&gOffscreen,0,&qd.screenBits.bounds,NULL,NULL,noNewDevice);
	if (err) FatalError(couldntGetOffscreen,err);
	EraseGWorld(gOffscreen);
	gPenType = boringNormal;
	gPenSize = 1;
	gPenMode = patCopy;
	gSHNeedsIdle = false;
	
	err = SHInitSoundHelper(&gSHNeedsIdle,0);
	if (err) FatalError(couldntStartSoundHelper,err);
	
	WindToOffscreen();
	gDefWinSize = gWindow->portRect;
	gPictFileRefNum = 0;
	gPict = NULL;
	SetStdCProcs(&gCQDProcs);
	gWindow->grafProcs = &gCQDProcs;
	
	gFillCursor = GetCursor(fillCursorID);
	if (MemError()) err = MemError(); else err = ResError();
	if (!gFillCursor) FatalError(couldntGetCursor,err);
	gTheCursor = NULL;
	gTool = tPaint; /* i.e. not fill */
	
	SetPort((WindowPtr)gWindow);
}

/* Note: These next 2 routines ARE highly specialized, and I don't care. */

void TurnOn(DialogPtr dialog, short turnOn)
{
	short ignored;
	Handle theItem;
	Rect dummy;
	
	GetDItem(dialog,turnOn,&ignored,&theItem,&dummy);
	SetCtlValue((ControlHandle) theItem,1);
}

void TurnOff(DialogPtr dialog, short turnOff1, short turnOff2, short turnOff3)
{
	short ignored;
	Handle theItem;
	Rect dummy;
	
	// What are your three most disgusting turnoffs?
	GetDItem(dialog,turnOff1,&ignored,&theItem,&dummy);
	SetCtlValue((ControlHandle) theItem,0);
	GetDItem(dialog,turnOff2,&ignored,&theItem,&dummy);
	SetCtlValue((ControlHandle) theItem,0);
	GetDItem(dialog,turnOff3,&ignored,&theItem,&dummy);
	SetCtlValue((ControlHandle) theItem,0);
}

void DoPenSize(void)
{
	DialogPtr dialog;
	short itemHit;
	short ignored;
	Handle theItem;
	Rect dummy;
	long theNum;
	Str255 theText;
	
	dialog = GetNewDialog(dPenSize,NULL,FRONT);
	if (!dialog) return;
	GetDItem(dialog,2,&ignored,&theItem,&dummy);
	NumToString((long)gPenSize,theText);
	SetIText(theItem,theText);
	do
	{
		ModalDialog(NULL,&itemHit);
	}
	while (itemHit != ok);
	
	GetDItem(dialog,2,&ignored,&theItem,&dummy);
	GetIText(theItem,theText);
	StringToNum(theText,&theNum);
	if (theNum > 0)
		gPenSize = (short) theNum;
	
	DisposDialog(dialog);
}

RGBColor DoPickColor(Str255 prompt)
{
	Boolean result;
	Point where;
	RGBColor color;
	
	color.red = 0; color.green = 0; color.blue = 0;
	where.h = 0; where.v = 0;
	if (!GetColor(where,prompt,&color,&color))
		return;
	return color;
}

void Toggle(DialogPtr dialog, short toggle)
{
	short ignored;
	ControlHandle theItem;
	Rect dummy;
	
	GetDItem(dialog,toggle,&ignored,(Handle *)&theItem,&dummy);
	SetCtlValue(theItem,!((**theItem).contrlValue));
}

void FixMenus(void)
{
	MenuHandle menu;
	WindowPtr window;
	
	/* Fix the menus. */
	HiliteMenu(0);
	menu = GetMHandle(mApple);
	EnableItem(menu,iAbout);
	menu = GetMHandle(mFile);
	EnableItem(menu,iNew);
	EnableItem(menu,iOpen);
	EnableItem(menu,iClose);
	if (!((WindowPeek)gWindow)->visible) DisableItem(menu,iClose);
	EnableItem(menu,iSave);
	if (!((WindowPeek)gWindow)->visible) DisableItem(menu,iSave);
	EnableItem(menu,iQuit);
	window = FrontWindow();
	menu = GetMHandle(mEdit);
	if (((WindowPeek)window)->windowKind < 0)
	{
		EnableItem(menu,iUndo);
		EnableItem(menu,iCut);
		EnableItem(menu,iEditCopy);
		EnableItem(menu,iPaste);
		EnableItem(menu,iClear);
		EnableItem(menu,iSelectAll);
		EnableItem(menu,iShowClipboard);
	}
	else
	{
		DisableItem(menu,iUndo);
		DisableItem(menu,iCut);
		DisableItem(menu,iEditCopy);
		DisableItem(menu,iPaste);
		DisableItem(menu,iClear);
		DisableItem(menu,iSelectAll);
		DisableItem(menu,iShowClipboard);
	}
	menu = GetMHandle(mPaint);
	if (!((WindowPeek)gWindow)->visible)
	{
		DisableItem(menu,iErase);
		DisableItem(menu,iPenSize);
		DisableItem(menu,iPenMode);
		DisableItem(menu,iPenType);
		DisableItem(menu,iFunky);
		DisableItem(menu,iInvert);
		DisableItem(menu,iBlend);
	}
	else
	{
		EnableItem(menu,iErase);
		EnableItem(menu,iPenSize);
		EnableItem(menu,iPenMode);
		EnableItem(menu,iPenType);
		EnableItem(menu,iFunky);
		EnableItem(menu,iInvert);
		EnableItem(menu,iBlend);
	}	
	menu = GetMHandle(mColor);
	if (!((WindowPeek)gWindow)->visible)
	{
		DisableItem(menu,iRed);
		DisableItem(menu,iOrange);
		DisableItem(menu,iYellow);
		DisableItem(menu,iGreen);
		DisableItem(menu,iCyan);
		DisableItem(menu,iRobinsEgg);
		DisableItem(menu,iBlue);
		DisableItem(menu,iPurple);
		DisableItem(menu,iLavender);
		DisableItem(menu,iMagenta);
		DisableItem(menu,iTan);
		DisableItem(menu,iBrown);
		DisableItem(menu,iBlack);
		DisableItem(menu,iDarkGray);
		DisableItem(menu,iLightGray);
		DisableItem(menu,iWhite);
		DisableItem(menu,iPickColor);
	}
	else
	{
		EnableItem(menu,iRed);
		EnableItem(menu,iOrange);
		EnableItem(menu,iYellow);
		EnableItem(menu,iGreen);
		EnableItem(menu,iCyan);
		EnableItem(menu,iRobinsEgg);
		EnableItem(menu,iBlue);
		EnableItem(menu,iPurple);
		EnableItem(menu,iLavender);
		EnableItem(menu,iMagenta);
		EnableItem(menu,iTan);
		EnableItem(menu,iBrown);
		EnableItem(menu,iBlack);
		EnableItem(menu,iDarkGray);
		EnableItem(menu,iLightGray);
		EnableItem(menu,iWhite);
		EnableItem(menu,iPickColor);
	}	
	menu = GetMHandle(mSound);
	if (!((WindowPeek)gWindow)->visible)
	{
		DisableItem(menu,iSoundtrack);
		DisableItem(menu,iBeep);
		DisableItem(menu,iOhWow);
		DisableItem(menu,iBlart);
		DisableItem(menu,iGlitch);
		DisableItem(menu,iWEBN);
		DisableItem(menu,iKerblooie);
		DisableItem(menu,iStopMusic);
	}
	else
	{
		EnableItem(menu,iSoundtrack);
		EnableItem(menu,iBeep);
		EnableItem(menu,iOhWow);
		EnableItem(menu,iBlart);
		EnableItem(menu,iGlitch);
		EnableItem(menu,iWEBN);
		EnableItem(menu,iKerblooie);
		EnableItem(menu,iStopMusic);
	}	
	if (soundTrackPlay)
		{ SetItemMark(menu,iSoundtrack,checkMark); return; }
	else
		{ SetItemMark(menu,iSoundtrack,noMark); return; }
}

void DoPenMode(void)
{
	DialogPtr dialog;
	short itemHit;
	Boolean not = false;
	
	dialog = GetNewDialog(dPenMode,NULL,FRONT);
	if (!dialog) return;
	do
	{
		ModalDialog(NULL,&itemHit);
		switch(itemHit)
		{
			case 3: Toggle(dialog,3); not = !not; break;
			case 4: TurnOn(dialog,4); TurnOff(dialog,5,6,7); gPenMode = patCopy; break;
			case 5: TurnOn(dialog,5); TurnOff(dialog,4,6,7); gPenMode = patOr; break;
			case 6: TurnOn(dialog,6); TurnOff(dialog,5,4,7); gPenMode = patXor; break;
			case 7: TurnOn(dialog,7); TurnOff(dialog,5,6,4); gPenMode = patBic; break;
		}
	}
	while (itemHit != ok);
	
	if (not) gPenMode += 4;		// read the first couple of lines of quickdraw.h
								// for an explanation.
	
	DisposDialog(dialog);
}

void DoPenType(void)
{
	DialogPtr dialog;
	short itemHit;

	dialog = GetNewDialog(dPenType,NULL,FRONT);
	if (!dialog) return;
	do
	{
		ModalDialog(NULL,&itemHit);
		switch(itemHit)
		{
			case 3: gPenType = boringNormal; TurnOn(dialog,3); TurnOff(dialog,4,5,6);
				break;
			case 4: gPenType = randomSize; TurnOn(dialog,4); TurnOff(dialog,3,5,6);
				break;
			case 5: gPenType = randomColor; TurnOn(dialog,5); TurnOff(dialog,4,3,6);
				break;
			case 6: gPenType = randomColorSize; TurnOn(dialog,6); TurnOff(dialog,4,5,3);
				break;
		}
	}
	while (itemHit != ok);
	
	DisposDialog(dialog);
}

void DoSoundChoice(short item)
{
	EventRecord event;
	Boolean dummy;
	
	switch(item)
	{
		case iSoundtrack:
			if (!soundTrackPlay)
			{
				SHPlayByID(sSoundtrack,&soundtrackRef);
				soundTrackPlay = true;
			}
			else
			{
				SHPlayStop(soundtrackRef);
				soundTrackPlay = false;
			}
		break;
		case iBeep:
			SysBeep(1);
		break;
		case iOhWow:
			SHPlayByID(sOhWow,&ref[0]);
		break;
		case iBlart:
			SHPlayByID(sBlart,&ref[1]);
		break;
		case iGlitch:
			SHPlayByID(sGlitch,&ref[2]);
		break;
		case iWEBN:
			SHPlayByID(sWEBN,&ref[3]);
		break;
		case iKerblooie:
			SHPlayByID(sKerblooie,&ref[4]);
		break;
		case iStopMusic:
			SHPlayStopAll();
			soundTrackPlay = false;
		break;
	}
	FixMenus();
}

void Sleep(short seconds)
{
	long ticks;
	
	Delay(seconds * 60,&ticks);
}

void DoSecret(void)
{
	CWindowPtr sWindow;
	RGBColor rgb;
	Str255 str;
	short i;
	Rect box;
	
	WindToOffscreen();
	sWindow = (CWindowPtr) GetNewCWindow(secretCredits,NULL,FRONT);
	SetPort((WindowPtr)sWindow);
	MoveTo(15,20);
	TextFont(geneva);
	TextSize(12);
	TextFace(bold);
	DrawString("\pIdiotPaint Credits! Moof!");
	TextFont(times);
	TextSize(18);
	TextFace(bold);
	rgb.red = 0; rgb.green = 270; rgb.blue = -1;
	RGBForeColor(&rgb);
	SetRect(&box,sWindow->portRect.left,sWindow->portRect.top,
		sWindow->portRect.right,sWindow->portRect.bottom);
	InsetRect(&box,0,50);

	for(i=1;i<24;i++)
	{
		GetIndString(str,secretCredits,i);
		EraseRect(&box);
		TextBox(PTR(((long) str) + 1),(* ((char *) str)),&box,teJustCenter);
		Sleep(2);
		if(Button()) break;
	}
	
	PenSize(8,8);
	rgb.red = 0; rgb.green = 0; rgb.blue = 0;
	RGBForeColor(&rgb);
	for(i=1;i<130;i+=8)
	{
		MoveTo(120 - i,0);
		LineTo(120 - i,155);
		MoveTo(240 - (120 - i),0);
		LineTo(240 - (120 - i),155);
		Sleep(1);
	}

	DisposeWindow((WindowPtr)sWindow);
	SetPort((WindowPtr)gWindow);
	OffscreenToWind();
}

void CalcColor(double percent, RGBColor begin,
					RGBColor end, RGBColor *result)
{
	result->red = begin.red +
		(unsigned short)(ceil(percent * (double)(end.red - begin.red)));
	result->green = begin.green +
		(unsigned short)(ceil(percent * (double)(end.green - begin.green)));
	result->blue = begin.blue +
		(unsigned short)(ceil(percent * (double)(end.blue - begin.blue)));
}

void DoBlend(void)
{
	RGBColor beginColor, currentColor, endColor;
	short x,
		rightEdge = gWindow->portRect.right,
		bottomEdge = gWindow->portRect.bottom;
	Point where;
	double percent, end = rightEdge;
	
	SetPort((WindowPtr)gWindow);
	beginColor = gPenColor;
	currentColor = beginColor;
	
	rightEdge -= 16;
	bottomEdge -= 16;
	end -= gWindow->portRect.left;
	
	where.h = 60; where.v = 60;
	if(!GetColor(where,"\pBlend from current color to:",&beginColor,&endColor))
		return;
				
	MoveTo(-1,0);
	
	for (x = 0; x <= rightEdge; x++)
	{
		/* Draw 1 line. */
		MoveTo(x,0);
		RGBForeColor(&currentColor);
		Line(0,bottomEdge);
		
		/* Calculate next color. */
		percent = ((double)x) / end;
		CalcColor(percent,beginColor,endColor,&currentColor);
	}
	WindToOffscreen();
}

void GetPicDimensions(PicHandle pic, short *height, short *width)
{
	*height = (*pic)->picFrame.bottom - (*pic)->picFrame.top;
	*width = (*pic)->picFrame.right - (*pic)->picFrame.left;
}

extern OSErr	GetPictFromCamera( short digitizerDepth, PicHandle *pic );
void DoFrameGrab(void)
{
	PicHandle pic;
	Rect frame = gWindow->portRect;
	GDHandle gd;
	CGrafPtr cp;
	OSErr err;
	
	if ((err = GetPictFromCamera(16,&pic)) != noErr) {
		GenericErr("\pgrabbing frame from camera",err);
		return;
	}
	SetPort((WindowPtr)gWindow);
	frame.right -= 15;
	frame.bottom -= 15;
	DrawPicture(pic,&frame);
	WindToOffscreen();
	KillPicture(pic);
	InvalRect(&gWindow->portRect);
}

void DoNew(void)
{
	short itemHit;
	
	if (((WindowPeek)gWindow)->visible)
	{
		itemHit = Alert(reallyDoNewAlrt,NULL);
		if (itemHit != 1) return;
		SHPlayByID(sKerblooie,&ref[4]);
	}
	else
		ShowWindow((WindowPtr)gWindow);
	SetPort((WindowPtr)gWindow);
	EraseRect(&gWindow->portRect);
	WindToOffscreen();
	InvalRect(&gWindow->portRect);
	gPenColor.red = 0; gPenColor.green = 0; gPenColor.blue = 0;
	gPenType = boringNormal;
	SHPlayStopAll();
	soundTrackPlay = false;
}

void PixDepthChanged(short theNewDepth)
{
	(void)UpdateGWorld(&gOffscreen,theNewDepth,&qd.screenBits.bounds,0,NULL,0);
}

void DoOpen(void)
{
	StandardFileReply reply;
	SFTypeList typeList;
	long count;
	short numTypes;
	short pHgt, pWid, mHgt, mWid;
	OSErr err;
	Rect r;
		
	/* Get name of file to open */
	numTypes = 1;
	typeList[0] = 'PICT';
	StandardGetFile(NULL, 1, typeList, &reply);
	if (!reply.sfGood) return;
	
	/* Open the file */	
	err = FSpOpenDF(&reply.sfFile,fsRdPerm,&gPictFileRefNum);
	if (err) { PictIOErr("\popening",err); return; }

	/* Find size of picture */
	GetEOF(gPictFileRefNum,&count);
	count -= 512;
	
	/* Seek past header */
	SetFPos(gPictFileRefNum, fsFromStart, 512L);
	
	/* Alloc space for pic data */
	gPict = (PicHandle)NewHandle(count);
	if (!gPict)
	{
		PictIOErr("\pallocating memory for",err);
		FSClose(gPictFileRefNum);
		return;
	}
	
	/* Slurp pic data from file */
	if ((err = FSRead(gPictFileRefNum,&count,*gPict)) != noErr) {
		PictIOErr("\preading",err);
		DisposeHandle((Handle)gPict);
		FSClose(gPictFileRefNum);
		return;
	}
	
	/* We're done with the file */
	FSClose(gPictFileRefNum);
	
	/* Setup window to be correct size for drawing */
	SetPort((WindowPtr)gWindow);
	GetPicDimensions(gPict,&pHgt, &pWid);
	mHgt = gMaxWinSize.bottom - gMaxWinSize.top;
	mWid = gMaxWinSize.right - gMaxWinSize.left;
	ShowWindow((WindowPtr)gWindow);
	if ((pHgt > mHgt) || (pWid > mWid))
	{
		(void)Alert(scalageAlrt,NULL);
		pWid = mWid; pHgt = mHgt;
		MoveWindow((WindowPtr)gWindow,gMaxSizeLoc.h,gMaxSizeLoc.v,false);
		SetRect(&(*gPict)->picFrame,0,0,pWid,pHgt);
		if (pHgt <= mHgt) mHgt = pHgt;
		if (pWid <= mWid) mWid = pWid;
		SizeWindow((WindowPtr)gWindow,mWid,mHgt,false);
	}
	else
	{
		SetRect(&(*gPict)->picFrame,0,0,pWid,pHgt);
		SizeWindow((WindowPtr)gWindow,pWid,pHgt,false);
	}
	
	/* Draw pict into window */
	r = (*gPict)->picFrame; r.bottom -= 16; r.right -= 16;
	SetBW(TRUE);
	DrawPicture(gPict, &r);
	SetBW(FALSE);
	WindToOffscreen();
	
	/* We're done with pict */
	DisposeHandle((Handle)gPict);
}

void DoClose(void)
{
	short itemHit;
	
	itemHit = Alert(reallyDoCloseAlrt,NULL);
	if (itemHit != 1) return;
	SetPort((WindowPtr)gWindow);
	EraseRect(&gWindow->portRect);
	WindToOffscreen();
	InvalRect(&gWindow->portRect);
	gPenColor.red = 0; gPenColor.green = 0; gPenColor.blue = 0;
	gPenType = boringNormal;
	SHPlayStopAll();
	soundTrackPlay = false;
	HideWindow((WindowPtr)gWindow);
	gWindow->portRect = gDefWinSize;
}

pascal void WritePictData(Ptr dataPtr, short byteCount)
{
	long theCount = byteCount;
	OSErr err;
	
	if ((err = FSWrite(gPictFileRefNum,&theCount,dataPtr)) != noErr)
		PictIOErr("\pwriting",err);
	if (gPict) (*gPict)->picSize += theCount;
}

void DoSave(void)
{
	OSErr				err;
	short				i, vrefnum;
	/* size of pict header */
	const long			header_size = 512; 
	long				header_longs = header_size / 4;
	Point				where;
	unsigned long		*header, *p;
	StandardFileReply	reply;
	CGrafPort			myPort;
	CGrafPtr			myPortPtr, oldPort;
	Rect				pictRect;
	long 				longCount;
	OpenCPicParams		picParams;
		
	StandardPutFile("\pDump painting as:", "\pIdiotPainting", &reply);
	if (!reply.sfGood) return;

	/* Setup port, clipping */
	SetPort((WindowPtr)gWindow);
	SetRect(&pictRect,0,0,gWindow->portRect.right - 15,
		gWindow->portRect.bottom - 15);
	ClipRect(&pictRect);
	
	/* Setup picParams */
	picParams.srcRect = pictRect;
	picParams.hRes = picParams.vRes = 72L << 16; /* 72 x 72 dpi */
	picParams.version = -2;
	picParams.reserved1 = picParams.reserved2 = 0L;
	
	/* Create and open a PICT file */
	err = FSpCreate(&reply.sfFile, 'Pain', 'PICT', reply.sfScript);
	if (err) { PictIOErr("\pcreating",err); return; }
	err = FSpOpenDF(&reply.sfFile, fsWrPerm, &gPictFileRefNum);
	if (err) { PictIOErr("\popening",err); return; }
	
	/* Write silly 512 byte pict header */
	header = (unsigned long *) NewPtr(header_size);
	p = header;
	while (header_longs--) *p++ = 0xDEADBEEF;
	longCount = header_size;
	(void)FSWrite(gPictFileRefNum,&longCount,&header);
	DisposePtr((Ptr)header);
	
	/* Assemble our pixmap into a picHandle */
	OffscreenToWind();
	SetBW(TRUE);
	gPict = OpenCPicture(&picParams);
	CopyBits((BitMapPtr)*(gWindow->portPixMap),
		(BitMapPtr)*(gWindow->portPixMap),
		&pictRect,&pictRect,srcCopy,NULL);
	ClosePicture();
	SetBW(FALSE);
	
	/* Write out a flat pichandle to the file */
	longCount = GetHandleSize((Handle)gPict);
	HLock((Handle) gPict);
	err = FSWrite(gPictFileRefNum, &longCount, *gPict);
	HUnlock((Handle) gPict);
	if (err) { PictIOErr("\pwriting",err); }
	
	/* Dispose of picHandle */
 	KillPicture(gPict);
 	(void)FSClose(gPictFileRefNum);
}

void DoFill(void)
{
	if (Alert(blowsUpAlrt,NULL) == ok) return;
	gTheCursor = gFillCursor; 
	gTool = tFill;
}

void FillAtPoint(Point *where, RGBColor *color)
{
	BitMap *srcBits, dstBits;
	Rect *srcRect, *dstRect;
	
	srcBits = (BitMapPtr)*(gWindow->portPixMap);
	dstBits = *srcBits;
	dstBits.baseAddr = NewPtr(GetPtrSize(srcBits->baseAddr));
	srcRect = &srcBits->bounds;
	dstRect = &srcBits->bounds;
	SeedCFill(srcBits, &dstBits, srcRect, dstRect, where->h, where->v, NULL, 0L);
	RGBForeColor(color);
	CopyBits(&dstBits, srcBits, dstRect, srcRect, srcOr, NULL);
	DisposePtr(dstBits.baseAddr);
	gTool=tPaint;
	gTheCursor = NULL;
}

void DoMenu(long selection)
{
	short menu, item, ignored, i, right, bottom, gleep;
	Str255 daName;
	Point pt;
	double percent;
	RGBColor original, current, target, rgb;
	Rect r;
	RgnHandle tempRgn;
	Boolean dummy;
	EventRecord event;
	unsigned int cur, orig, tar, foo;
	
	menu = HiWrd(selection);
	item = LoWrd(selection);
	
	switch(menu)
	{
		case mApple:
			switch(item)
			{
				case iAbout:
					dummy = EventAvail(everyEvent,&event);
					if (event.modifiers & optionKey)
						DoSecret();
					else
						ignored = Alert(aboutAlrt, NULL);
				break;
				default:
					GetItem(GetMHandle(mApple), item, daName);
					ignored = OpenDeskAcc(daName);
				break;
			}
		break;
		case mFile:
			switch(item)
			{
				case iNew:
					DoNew();
				break;
				case iOpen:
					DoOpen();
				break;
				case iClose:
					DoClose();
				break;
				case iSave:
					DoSave();
				break;
				case iQuit:
					gDone = true;
				break;
			}
		break;
		case mEdit:
			ignored = SystemEdit(item-1);
		break;
		case mPaint:
			switch(item)
			{
				case iErase:
					EraseRect(&gWindow->portRect);
					EraseGWorld(gOffscreen);
					InvalRect(&gWindow->portRect);
				break;
				case iFunky:					
					do { ignored = Rand(4); } while ((ignored < 1) || (ignored > 3));
					switch(ignored)
					{
						case 1:
							for(i=0;i<200;i++)
							{
								SetRect(&r,
									Rand(gWindow->portRect.right - 15),
									Rand(gWindow->portRect.bottom - 15),
									Rand(gWindow->portRect.right - 15),
									Rand(gWindow->portRect.bottom - 15));
								rgb.red = Random();
								rgb.green = Random();
								rgb.blue = Random();
								RGBForeColor(&rgb);
								FrameOval(&r);
							}
						break;
						case 2:
							for(i=0;i<200;i++)
							{
								SetRect(&r,
									Rand(gWindow->portRect.right - 15),
									Rand(gWindow->portRect.bottom - 15),
									Rand(gWindow->portRect.right - 15),
									Rand(gWindow->portRect.bottom - 15));
								rgb.red = Random();
								rgb.green = Random();
								rgb.blue = Random();
								RGBForeColor(&rgb);
								FrameRect(&r);
							}
						break;
						case 3:
							TextFont(0);
							TextSize(48);
							for(i=0;i<200;i++)
							{
								SetPt(&pt,
									Rand(gWindow->portRect.right - 45),
									Rand(gWindow->portRect.bottom - 45));
								rgb.red = Random();
								rgb.green = Random();
								rgb.blue = Random();
								RGBForeColor(&rgb);
								MoveTo(pt.h,pt.v);
								DrawChar((char) Rand(223) + 32);
							}
							TextSize(12);
							TextFont(1);
						break;
						default: break;
						
					}
					WindToOffscreen();
				break;
				case iPenSize: DoPenSize(); break;
				case iPenMode: DoPenMode(); break;
				case iPenType: DoPenType(); break;
				case iInvert:
					gWindow->portRect.bottom -= 15;
					gWindow->portRect.right -= 15;
					InvertRect(&gWindow->portRect);
					gWindow->portRect.bottom += 15;
					gWindow->portRect.right += 15;
					WindToOffscreen();
					InvalRect(&gWindow->portRect);
				break; /* Franki-90210 must die */
				case iBlend:
					DoBlend();
				break;
				case iFill:
					DoFill();
				break;
				case iFrameGrab:
					DoFrameGrab();
				break;
			}
		break;
		case mColor:
			switch(item)
			{
			case iRed:
				gPenColor.red = 65535; gPenColor.green = 0; gPenColor.blue = 0;
			break;
			case iOrange:
				gPenColor.red = 65535; gPenColor.green = 32767; gPenColor.blue = 0;
			break;
			case iYellow:
				gPenColor.red = 65535; gPenColor.green = 65535; gPenColor.blue = 0;
			break;
			case iGreen:
				gPenColor.red = 0; gPenColor.green = 65535; gPenColor.blue = 0;
			break;
			case iCyan:
				gPenColor.red = 0; gPenColor.green = 65535; gPenColor.blue = 65535;
			break;
			case iRobinsEgg:
				gPenColor.red = 0; gPenColor.green = 45874; gPenColor.blue = 65535;
			break;
			case iBlue:
				gPenColor.red = 0; gPenColor.green = 0; gPenColor.blue = 65535;
			break;
			case iPurple:
				gPenColor.red = 32767; gPenColor.green = 0; gPenColor.blue = 65535;
			break;
			case iLavender:
				gPenColor.red = 40000; gPenColor.green = 29000; gPenColor.blue = 65535;
			break;
			case iMagenta:
				gPenColor.red = 65535; gPenColor.green = 0; gPenColor.blue = 65535;
			break;
			case iTan:
				gPenColor.red = 50000; gPenColor.green = 25000; gPenColor.blue = 25000;
			break;
			case iBrown:
				gPenColor.red = 25000; gPenColor.green = 12500; gPenColor.blue = 12500;
			break;
			case iBlack:
				gPenColor.red = 0; gPenColor.green = 0; gPenColor.blue = 0;
			break;
			case iDarkGray:
				gPenColor.red = 13107; gPenColor.green = 13107; gPenColor.blue = 13107;
			break;
			case iLightGray:
				gPenColor.red = 52428; gPenColor.green = 52428; gPenColor.blue = 52428;
			break;
			case iWhite:
				gPenColor.red = 65535; gPenColor.green = 65535; gPenColor.blue = 65535;
			break;
			case iPickColor:
				gPenColor = DoPickColor("\pPick a color, any color");
			break;
			}
			if (gPenType == randomColorSize) { gPenType = randomSize; break; }
			if (gPenType == randomColor) { gPenType = boringNormal; break; }
		break;
		case mSound: DoSoundChoice(item); break;
	}
	HiliteMenu(0);
}

void SetMyCursor(void)
{
	if (gTheCursor == NULL)
		InitCursor();
	else
		SetCursor(*gTheCursor);
}

void DoNullEvent(EventRecord event)
{
	/* Idle time processing. */
	SetMyCursor(); /* bad? */
	FixMenus();
}

void DoContentClick(EventRecord event, WindowPtr window)
{
	Point mouse;
	RGBColor rgb;
	RgnHandle tempRgn;
	short sizeH, sizeV;
	
	tempRgn = NewRgn();
	CopyRgn(gWindow->clipRgn,tempRgn);
	SetRectRgn(gWindow->clipRgn,0,0,gWindow->portRect.right - 15,
		gWindow->portRect.bottom - 15);
	
	GetMouse(&mouse);
	MoveTo(mouse.h,mouse.v);
	while (Button())
	{
		GetMouse(&mouse);
		PenMode(gPenMode);
		if ((gPenType == randomColor) || (gPenType == randomColorSize)) {
			rgb.red = Random();
			rgb.green = Random();
			rgb.blue = Random();
		}
		else
			rgb = gPenColor;
		RGBForeColor(&rgb);
		
		if ((gPenType == randomSize) || (gPenType == randomColorSize)) {
			sizeH = Random() % gPenSize;
			sizeV = Random() % gPenSize;
		} else {
			sizeH = sizeV = gPenSize;
		}
		PenSize(sizeH,sizeV);
		
		if (gTool == tFill) {
		/* this is heinous and evil and really bad
		 * but it's not as bad as: if (gNextClickIsFillNotPaint--) { fill stuff }
		 * it should be more like (*gToolJumpVecs[gTool])(&mouse,&rgb);
		 */
			 FillAtPoint(&mouse,&rgb);
			 break;
		}
		else if (gTool == tPaint) 
			LineTo(mouse.h,mouse.v);
		else
			/* don't complain.... things could be worse */;
	}
	WindToOffscreen();
	CopyRgn(tempRgn,gWindow->clipRgn);
	DisposeRgn(tempRgn);
}

void DoMouseDown(EventRecord event)
{
	/* Respond to click. */
	short part;
	long newSize;
	WindowPtr window; // Windows.h
	
	part = FindWindow(event.where, &window);
	switch(part)
	{
		case inMenuBar: 
			DoMenu(MenuSelect(event.where));
		break;
		case inContent: 
			if (window != FrontWindow())
				SelectWindow(window);
			else
				DoContentClick(event, window);
		break;
		case inSysWindow: 
			SystemClick(&event, window);
		break;
		case inDrag: 
			DragWindow(window, event.where, &qd.screenBits.bounds);
			EraseGWorld(gOffscreen);
		break;
		case inGrow:
			newSize = GrowWindow(window, event.where, &qd.screenBits.bounds);
			WindToOffscreen();
			EraseRect(&window->portRect);
			SizeWindow(window,LoWrd(newSize),HiWrd(newSize),true);
			OffscreenToWind();
			InvalRect(&window->portRect);
		break;
		case inGoAway:
			if (TrackGoAway(window,event.where)) DoClose();
		break;
		case inZoomIn:
		case inZoomOut:
			if (TrackBox(window,event.where,part))
			{
				SetPort(window);
				WindToOffscreen();		
				EraseRect(&window->portRect);
				ZoomWindow(window, part, true);
				InvalRect(&window->portRect);
			}
		break;
	}
}

void DoKeyDown(EventRecord event)
{
	char ch;
	
	ch = (char) (event.message & 0xFF);
	if (event.modifiers & cmdKey)
	{
		DoMenu(MenuKey(ch));
		return;
	}
	
	if (ch != 0x08)
	{
		DrawChar(ch);
		WindToOffscreen();
	}
	else
		SysBeep(1);
}


void DoUpdateEvt(EventRecord event)
{
	WindowPtr window;
	Rect r;
	PenState pen;
	RGBColor rgb;
	CGrafPtr cp;
	GDHandle gd;
	RgnHandle tempRgn;
	
	window = (WindowPtr) event.message;
	if ((!EmptyRgn(window->visRgn)) && (((WindowPeek)window)->refCon = OUR_WINDOW))
	{
		SetPort(window);
		tempRgn = NewRgn();
		CopyRgn(gWindow->clipRgn,tempRgn);
		SetRectRgn(gWindow->clipRgn,-32767,-32767,32767,32767);
		GetPenState(&pen);
		PenSize(1,1);
		PenMode(patCopy);
		rgb.red = 0; rgb.green = 0; rgb.blue = 0;
		RGBForeColor(&rgb);
		BeginUpdate(window);
			DrawGrowIcon(window);
			/*MoveTo(0,window->portRect.bottom - 15);
			LineTo(window->portRect.right,window->portRect.bottom - 15);
			MoveTo(window->portRect.right - 15,0);
			LineTo(window->portRect.right - 15,window->portRect.bottom);*/
		EndUpdate(window);
		SetPenState(&pen);
		CopyRgn(tempRgn,gWindow->clipRgn);
		DisposeRgn(tempRgn);
		OffscreenToWind();
	}
}

void DoActivateEvt(EventRecord event)
{
	/* Activate window. */
	WindowPtr window;
	
	if (event.modifiers & activeFlag)
	{
		window = (WindowPtr) event.message;
		if (window != FrontWindow()) SelectWindow(window);
		OffscreenToWind();
	}
	else
	{
		WindToOffscreen();
	}
}

void DoDiskEvt(EventRecord event)
{
	/* Disk insertion. */
	Point x;
	
	if (HiWrd(event.message) == noErr) return;
	x.h = 50; x.v = 50;
	DIBadMount(x,event.message);
}

void DoOSEvt(EventRecord event)
{		
	// Process manager wants your attn.
	switch ((event.message >> 24) & 0xFF)
	{
		case suspendResumeMessage:	// suspend/resume time
			// housekeeping call
			gInBackgnd = ((event.message & resumeFlag) == 0);
			if (gInBackgnd)
			{
				InitCursor();
				WindToOffscreen();
			}
			else
			{
				SetMyCursor();
				OffscreenToWind();
			}
		break;
	}	
}

void DoHighLevelEvent(EventRecord event)
{
	OSErr err;
	
	err = AEProcessAppleEvent(&event);
}

void HandleEvent(EventRecord event)
{
	switch(event.what)
	{
		case nullEvent:
			DoNullEvent(event); break;
		case mouseDown:
			DoMouseDown(event); break;
		case keyDown:
		case autoKey:
			DoKeyDown(event); break;
		case updateEvt:
			DoUpdateEvt(event); break;
		case activateEvt:
			DoActivateEvt(event); break;
		case diskEvt:
			DoDiskEvt(event); break;
		case osEvt:
			DoOSEvt(event); break;
		case highLevelEvent:
			DoHighLevelEvent(event); break;
	}
}

void MainLoop(void)
{
	Boolean gotEvent;
	EventRecord event;
	SHPlayStat stat;
	GDHandle maxgd;
	short maxcolors;
	PixMapHandle offPix;
	
	do
	{
		if (gSHNeedsIdle) SHIdle();
		if (soundTrackPlay)
		{
			stat = SHPlayStatus(soundtrackRef);
			if (stat == shpFinished)
				SHPlayByID(sSoundtrack,&soundtrackRef);
		}		
		maxgd = GetMaxDevice(&qd.screenBits.bounds);
		maxcolors = (**((**maxgd).gdPMap)).pixelSize;
		offPix = GetGWorldPixMap(gOffscreen);
		if (maxcolors != (**offPix).pixelSize) PixDepthChanged(maxcolors);
		
		gotEvent = WaitNextEvent(everyEvent,&event,SLEEPTIME,NULL);
		HandleEvent(event);
	}
	while (!gDone);
}

void CleanUp(void)
{
	DisposeWindow((WindowPtr)gWindow);
	DisposeGWorld(gOffscreen);
	SHKillSoundHelper();
}

void main(void)
{
	Initialize();
	MainLoop();
	CleanUp();
}
