
#include "frameGrab.h"

/* this code courtesy of Jorg Brown <jbx@MacGroup.COM> */

OSErr	GetPictFromCamera( short digitizerDepth, PicHandle *pic_r )
{
	PicHandle				thePict;
	OSErr					result;
	ComponentDescription	theCameraDesc;
	Component				theCamera;
	ComponentInstance		theCameraInstance;
	Rect					maxSrcRect;
	CGrafPtr				theWorld;
	CTabHandle				cTable;
	PixMapHandle			thePMH;
	short					videoInputSource;
	GWorldPtr				origGWorld;
	GDHandle				origGDevice;

	thePict = (PicHandle)NewHandle( sizeof(Picture) );
	if ( !thePict || MemError( ) )
		return MemError();

	//look for a color Camera
	theCameraDesc.componentType				=	sgVideoDigitizerType;
	theCameraDesc.componentSubType			=	0L;
	theCameraDesc.componentManufacturer		=	0L;
	theCameraDesc.componentFlags				=	0;
	theCameraDesc.componentFlagsMask			=	0;

	theCamera	=	FindNextComponent( 0, &theCameraDesc );
	if ( !theCamera )
		return -1;

	theCameraInstance = OpenComponent( theCamera );
	if ( !theCameraInstance )
		return -1;

	result = VDGetInput( theCameraInstance, &videoInputSource );
	if ( result )
		return result;

	result = VDGetMaxSrcRect( theCameraInstance, videoInputSource, &maxSrcRect );
	if ( result )
		return result;

	result = VDSetDigitizerRect( theCameraInstance, &maxSrcRect );
	if ( result )
		return result;

	cTable = digitizerDepth != 32 && digitizerDepth != 16 ? GetCTable( digitizerDepth ) : nil;
	result = NewGWorld( &theWorld, digitizerDepth, &maxSrcRect, cTable, nil, keepLocal );
	if ( cTable )
		DisposeCTable( cTable );
	if ( result )
		return result;

	thePMH = GetGWorldPixMap( theWorld );
	LockPixels( thePMH );

	result = VDSetPlayThruDestination( theCameraInstance, thePMH, &maxSrcRect, nil, nil );
	if ( result )
		return result;

	result = VDGrabOneFrame( theCameraInstance );
	if ( result )
		return result;

	GetGWorld( &origGWorld, &origGDevice );
	SetGWorld( theWorld, nil);		//get the pictures to save at the proper coordinates

	thePict = OpenPicture( &maxSrcRect );
	HLock( (Handle)thePMH );
	CopyBits( (BitMapPtr)*thePMH, (BitMapPtr)*thePMH, &maxSrcRect, &maxSrcRect, srcCopy, nil );
	HUnlock( (Handle)thePMH );
	ClosePicture( );

	if ( theWorld )
		DisposeGWorld( theWorld );

	SetGWorld( origGWorld, origGDevice );

	*pic_r = thePict;
	return noErr;
}











