/*  Copyright  1986 by the University of Michigan Medical Center.  All rights reserved

Filename:       clipdemo.h

Abstract:       This module contains declarations for the clipdemo and term source files

Environment:    UM/CLIP

Revision History:
   Rev #       Date         Auth    Reason
   -----    ----------      ----    ----------------------------------
    0.0     22 may, 86      daf     original implementation
=========================================================================================*/

#define     APAMIN      45          /* counterclockwise     */
#define     APAMAX      45          /* clockwise            */
#define     APBMIN      200         /* counterclockwise     */
#define     APBMAX      120         /* clockwise            */
#define     APDMIN      100         /* closest together     */
#define     APDMAX      400         /* furthest apart       */

#define     LATAMIN     90          /* counterclockwise     */
#define     LATAMAX     30          /* clockwise            */
#define     LATBMIN     70          /* counterclockwise     */
#define     LATBMAX     70          /* clockwise            */
#define     LATDMIN     100         /* closest together     */
#define     LATDMAX     400         /* furthest apart       */

#define     ISOCTOFS    700         /* iso-center to focal spot distance */    

void        ClipInit();
void        TermInit();
void        HndlMenus();
void        ShowAboutBox();
void        InitMicor();
void        KillMicor();
void        InitDigitron();
void        KillDigitron();
void        InitBICOR();
void        KillBICOR();
WindowPtr   MkBICORWindow();
void        HndlCntrls();
void        HndlDig();
void        HndlBICOR();
void        BICORValInit();
DOUBLE      MagFact();
void        drawAParcs();
void        drawLATarcs();
void        rotAlphAP();
void        rotBetaAP();
void        rotAlphLAT();
void        rotBetaLAT();

ERRCODE     mkmxa();
ERRCODE     mkmxl();
ERRCODE     mkmxii();
ERRCODE     mxmul();
DOUBLE      sin ();                     /* sine function */
DOUBLE      cos ();                     /* cosine function */

EventRecord         Event;              /* event record structure instance  */
EventStuff          whatHappened;       /* event detail structure instance  */
Rect                myRect,apRect,latRect;          /* rectangle instances  */
WindowRecord        mWind,dWind,BICORWind; 
WindowPtr           mWindPtr,dWindPtr,BWindPtr;
Cursor              iBeam,cross,plus,watch;     /* standard cursor handles  */
MenuHandle          appleMenu,fileMenu,editMenu;    /* standard menu handles*/
MenuHandle          toolMenu;               /* CLIP specific menu handles   */
MenuHandle          baudMenu,portMenu;      /* communications menu handles  */
static char         **updateRgn;
int                 x, y;
long                count;
Boolean             micor,digitron,Bicor,latArm,hostmode;
INT                 alphaAP,betaAP,distAP,alphaLAT,betaLAT,distLAT;
ControlHandle       apcntrls[10],latcntrls[10];
DOUBLE              aptopat[9],pattoap[9],lattopat[9],pattolat[9],aptolat[9],lattoap[9];
ControlHandle       digcoords[12];
DOUBLE              ptvect0[3],fsvect0[3],ptvectt[3],fsvectt[3];/* image coordinate system values */
DOUBLE              mf;

struct port {                           /* communications port settings info */
              int             refin, refout;
              unsigned short  baud, parity, stopbits, databits;
              char            *out, *in;
            } PortA, PortB, *Port;      /* two instances and a pointer       */
