/*

Copyright Apple Computer, Inc. 1981-1988

Rez -a -o "{SystemFolder}MacsBug" "{MPW}Debuggers:Macros.r"  "{Worksheet}"
Shutdown -r

*/


type 'mxbm'{
	integer = $$CountOf(symbols);          /* Number of entries     */
	array symbols { pString; pString; };   /* Macro name; expansion */
};
	
resource 'mxbm' (100) {
    {   /* Useful command lines */

	/* Break at the first instruction of a segment after loading it */
	"GS",			"SB 12D 1;G;T 2;SB 12D 0",

          /* Enter "GTO n" to go till offset n in the current procedure is reached */
    	"GTO",			"GT :+",

          /* Enter "BRO n" to set a breakpoint at offset n in the current procedure */
    	"BRO",			"BR :+",

	/* Displays the port assuming the A5 world is set up */
    	"thePort",		"DM A5^^ WindowRecord",

          /* IJ disassembles starting from the destination of a JMP instruction */
    	"IJ",			"IL (.+2)^",


       /* Low memory globals from Inside Mac volumes 1 thru 5 */
	"ABusVars",		"2D8",
	"ACount",			"A9A",
	"ANumber",		"A98",
	"ApFontID",		"984",
	"ApplLimit",		"130",
	"ApplScratch",		"A78",
	"ApplZone",		"2AA",
	"AppParmHandle",		"AEC",
	"AtMenuBottom",		"B28",
	"AuxCtlHead",		"CD4",
	"AuxWinHead",		"CD0",

	"BootDrive",		"210",
	"BufPtr",			"10C",
	"BufTgDate",		"304",
	"BufTgFBkNum",		"302",
	"BufTgFFlg",		"300",
	"BufTgFNum",		"2FC",

	"CaretTime",		"2F4",
	"CPUFlag",		"12F",
	"CrsrThresh",		"8EC",
	"CurActivate",		"A64",
	"CurApName",		"910",
	"CurApRefNum",		"900",
	"CurDeactive",		"A68",
	"CurDirStore",		"398",
	"CurJTOffset",		"934",
	"CurMap",			"A5A",
	"CurPageOption",		"936",
	"CurPitch",		"280",
	"CurrentA5",		"904",
	"CurStackBase",		"908",

	"DABeeper",		"A9C",
	"DAStrings",		"AA0",
	"DefltStack",		"322",
	"DefVCBPtr",		"352",
	"DeskHook",		"A6C",
	"DeskPattern",		"A3C",
	"DlgFont",		"AFA",
	"DoubleTime",		"2F0",
	"DragHook",		"9F6",
	"DragPattern",		"A34",
	"DrvQHdr",		"308",
	"DSAlertRect",		"3F8",
	"DSAlertTab",		"2BA",
	"DSErrCode",		"AF0",
	"DTQueue",		"D92",

	"EventQueue",		"14A",
	"ExtStsDT",		"2BE",

	"FCBSPtr",		"34E",
	"FinderName",		"2E0",
	"FractEnable",		"BF4",
	"FScaleDisable",		"A63",
	"FSFCBLen",		"3F6",
	"FSQHdr",			"360",

	"GhostWindow",		"A84",
	"GrayRgn",		"9EE",
	"GZRootHnd",		"328",

	"HeapEnd",		"114",
	"HiLiteRGB",		"DA0",
	"HWCfgFlags",		"B22",

	"IntlSpec",		"BA0",

	"JADBProc",		"6B8",
	"JDTInstall",		"D9C",
	"JFetch",			"8F4",
	"JIODone",		"8FC",
	"JournalFlag",		"8DE",
	"JournalRef",		"8E8",
	"JStash",			"8F8",
	"JVBLTask",		"D28",

	"KbdLast",		"218",
	"KbdMap",			"174",
	"KbdPadMap",		"17C",
	"KbdType",		"21E",
	"KeyRepThresh",		"190",
	"KeyThresh",		"18E",

	"LastFOND",		"BC2",
	"LoadTrap",		"12D",
	"Lvl1DT",			"192",
	"Lvl2DT",			"1B2",

	"MBarEnable",		"A20",
	"MBarHeight",		"BAA",
	"MBarHook",		"A2C",
	"MBarSaveLoc",		"B58",
	"MemErr",			"220",
	"MemTop",			"108",
	"MenuCInfo",		"D5C",
	"MenuDisable",		"B54",
	"MenuFlash",		"A24",
	"MenuHook",		"A30",
	"MenuList",		"A1C",
	"MinStack",		"31E",
	"MMU32Bit",		"14B2",

	"OldContent",		"9EA",
	"OldStructure",		"9E6",

	"PaintWhite",		"9DC",
	"PortAUse",		"290",
	"PortBUse",		"291",
	"PrintErr",		"944",

	"QDColors",		"8B0",

	"RAMBase",		"2B2",
	"ResErr",			"A60",
	"ResErrProc",		"AF2",
	"ResLoad",		"A5E",
	"ResumeProc",		"A8C",
	"RndSeed",		"156",
	"ROMBase",		"2AE",
	"RomFont0",		"980",
	"RomMapInsert",		"B9E",
	"Rom85",			"28E",

	"SaveUpdate",		"9DA",
	"SaveVisRgn",		"9F2",
	"SCCRd",			"1D8",
	"SCCWr",			"1DC",
	"ScrapCount",		"968",
	"ScrapHandle",		"964",
	"ScrapName",		"96C",
	"ScrapSize",		"960",
	"ScrapState",		"96A",
	"Scratch8",		"9FA",
	"Scratch20",		"1E4",
	"ScrDmpEnb",		"2F8",
	"ScreenRow",		"106",
	"ScrHRes",		"104",
	"ScrVRes",		"102",
	"ScrnBase",		"824",
	"SdVolume",		"260",
	"SEvtEnb",		"15C",
	"SFSaveDisk",		"214",
	"SoundBase",		"266",
	"SoundLevel",		"27F",
	"SoundPtr",		"262",
	"SPAlarm",		"200",
	"SPATalkA",		"1F9",
	"SPATalkB",		"1FA",
	"SPClikCaret",		"209",
	"SPConfig",		"1FB",
	"SPFont",			"204",
	"SPKbd",			"206",
	"SPMisc1",		"20A",
	"SPMisc2",		"20B",
	"SPPortA",		"1FC",
	"SPPortB",		"1FE",
	"SPPrint",		"207",
	"SPValid",		"1F8",
	"SPVolCtl",		"208",
	"StkLowPt",		"110",
	"SysEvtMask",		"144",
	"SysFontFam",		"BA6",
	"SysFontSize",		"BA8",
	"SynListHandle",		"D32",
	"SysMap",			"A58",
	"SysMapHndl",		"A54",
	"SysParam",		"1F8",
	"SysResName",		"AD8",
	"SysZone",		"2A6",

	"TEDoText",		"A70",
	"TERecal",		"A74",
	"TEScrpHandle",		"AB4",
	"TEScrpLength",		"AB0",
	"TheMenu",		"A26",
	"TheZone",		"118",
	"Ticks",			"16A",
	"Time",			"20C",
	"TimeDBRA",		"D00",
	"TmpResLoad",		"B9F",
	"ToExtFS",		"3F2",
	"ToolScratch",		"9CE",
	"TopMapHndl",		"A50",
	"TopMenuItem",		"B26",

	"UTableBase",		"11C",

	"VBLQueue",		"160",
	"VCBQHdr",		"356",
	"VIA",			"1DA",

	"WidthListHand",		"8E4",
	"WidthPtr",		"B10",
	"WidthTabHandle",		"B2A",
	"WindowList",		"9D6",
	"WMgrPort",		"9DE"
     };
};
