{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{$D+}

{------------------------------------------------------------------------------
MakeSA.p	Implements a tool for massaging a simple application into a
			single stand alone code resource.
			
	Syntax of MakeSA:
	
		MakeSA [options] filename [filenames]
	
	Options:
	
		-ct TYPE ---- set rsrc type of non-main code segments  (default = 'DUDE')
		-fc TYPE ---- set the creator attribute of the file    (default = 'RSED')
		-ft TYPE ---- set the type attribute of the file       (default = 'rsrc')
		-help ------- return this help text
		-id integer - set the rsrc ID of the MAIN segment      (default = 128)
		-mt TYPE ---- set the rsrc type of the MAIN segment    (default = 'DUDE')
		-mn Name ---- set the rsrc name of the MAIN segment    (default = '')
		-o filename - Name of the output file                  (default = input.dude)
		-[No]S ------ Allow for multi-segmented code           (default = -NoS)
		-[No]P ------ report progress to stdout                (default = -NoP)
		-[No]T ------ report processing time                   (default = -NoT)
			
NOTE - tools cannot currently be built with -debug Sorry!
------------------------------------------------------------------------------}
PROGRAM MakeSA;

USES
	{  MacApp }
	UMacApp,

	{  Building Blocks }

	{  Required for this unit's interface }
	UAssociation,

	{  Implementation use }
	CursorCtl, Signal, PasLibIntf, IntEnv, ErrMgr, Events, OSUtils, Memory,
	Resources, Fonts, Packages, ToolUtils, Errors, TextEdit,

	{  Inherits from }
	UMPWTool, UMakeSAGlobals, UMultiSegSA, USingleSegSA, UMakeSA;


{--------------------------------------------------------------------------------------------------}

{$S TRes}

	BEGIN
		gMakeSA := NIL;
		InitUMPWTool;
		New(gMakeSA);
		FailNil(gMakeSA);
		gMakeSA.IMakeSA;
		gMakeSA.Run;
	END.

{--------------------------------------------------------------------------------------------------}
