#if !defined(USEDUMP)
	#include "lprlib.h"
	#include "lprdef.h"
	#include "lprfuncs.h"
#else
	#pragma load "lprDumpFile"
#endif

unsigned char done;			/* true to exit program */
unsigned char bigscreen;	/* true if at least 640 by 480 */
unsigned char dfltcurs;		/* true if cursor is default */
short ioerror;				/* result from tcp_init */
unsigned char tcpinitok;	/* network code is active */
unsigned char pend_conn;	/* TCP/IP connection pending status */
unsigned char sw_bgrnd;		/* running in Switcher background */
unsigned char mf_bgrnd;		/* in background under MultiFinder */
struct Point sfppoint, sfgpoint;	/* standard file dialog locations */
MenuHandle myMenus[NMENUS];
struct EventRecord myEvent;
unsigned long * Ticks = 0x16a;
DialogPtr statptr;
unsigned char netstat[256];
unsigned char connstat[256];
unsigned char prtstat[256];

settings_list ds;			/* default settings */
settings_list cs;			/* current settings */
settings_list fs;			/* last settings to/from file */

unsigned char vmpass[9];	/* VM password */
unsigned long passtime;		/* time password last stored */
unsigned char printlist;	/* TRUE if list to be printed */

domainresult dns;			/* structure for domain lookup results */
unsigned char queueflags[64];	/* flags for our queue */
unsigned short queueevents[64];	/* corresponding events */

Rect dragRect, sizeRect;

extern unsigned char myipnum[4];	/* my IP number */
extern unsigned char * filelist;	/* pointer to list of files to process */
extern short currfnum;				/* 0 or reference for open file */
extern StreamPtr mystream;			/* pointer to our stream */
extern unsigned char prtstate;		/* lpr protocol state */
extern unsigned long prtstime;		/* time prtstate last changed */
extern void _DataInit();

main()
{
OSErr rc;
short i;

_DataInit();					/* Initialize global data */
UnloadSeg((Ptr) _DataInit);		/* note that _DataInit must not be in Main! */

tcpinitok = 0;				/* tcp network stuff not active */
pend_conn = 0;				/* no pending TCP/IP connection */
ioerror = 0;				/* no TCP/IP error yet */
dfltcurs = 1;				/* start with default cursor */
filelist = 0;				/* no list of files yet */
currfnum = 0;				/* no file open yet */
prtstate = 0;				/* no printing yet */
prtstime = 0;
dns.newresult = 0;			/* no completed domain lookup */
for (i = 0; i < 64; i++) {	/* queue is empty */
	queueflags[i] = 0;
	}
mystream = (StreamPtr)0;	/* no stream yet */
macinit();
watchcurs();				/* cursor -> watch during init */
hnd_init();
tcp_init();
resetcurs();				/* reset cursor */
if (ioerror != 0) {			/* return if tcp_init failed */
	macend();
	return;
	}
							/* define default settings */
passtime = 0;
memset(vmpass, 0, 9);
memset(&ds, 0, sizeof(settings_list));	/* start with zeros */
ds.timeout = 1;
ds.retries = 15;
ds.hdrflag = 1;
ds.fmttype = 2;
ds.copycnt = 1;
ds.fwidth = 80;
ds.splitflag = 1;
ds.fpgsize = 66;
ds.ftabsize = 4;
ds.duplex = 0;
ds.newprot = 0;
strcpy(ds.orghost, "Macintosh");
getdflt(ds.orguser, 64, 'STR ', -16096);
if (ds.orguser[0] == 0)
	strcpy(ds.orguser, "Macintosh_user");
else fixblank(ds.orguser, 64);		/* embedded blanks -> '_' */
memcpy(ds.hdrid, ds.orguser, 64);
strcpy(ds.jobname, "Macintosh");
sprintf(ds.hdrclass, "%d.%d.%d.%d", myipnum[0], myipnum[1],
	myipnum[2], myipnum[3]);
getdflt(ds.hostname, 128, 'hnam', 0);
if (ds.hostname[0] == 0)
	strcpy(ds.hostname, "yourhost.yoursite.yourdomain");
else fixblank(ds.hostname, 128);
getdflt(ds.printer, 64, 'hprt', 0);
if (ds.printer[0] == 0)
	strcpy(ds.printer, "lp");
else fixblank(ds.printer, 64);
strcpy(ds.vmclass, "A");
strcpy(ds.vmform, "STANDARD");
cs = ds;					/* set default settings */
rc = init_settings();		/* get initial settings */
if ((cs.fmttype < 1) || (cs.fmttype > 3)) cs.fmttype = ds.fmttype;
done = 0;
while (!done) hndmac();		/* handle Mac events and I/O */
tcp_end();
macend();					/* clean-up Mac */
}

void hnd_init(void)			/* handle events during intialization */
{
short evtrc;

evtrc = GetNextEvent(activMask+updateMask, &myEvent);
while (evtrc != 0) {
	switch(myEvent.what) {
		case activateEvt:
						if (((struct GrafPort *)myEvent.message == statptr)
								&& statptr) statGrowIcon();
								break;
		case updateEvt:
								updevent((GrafPtr)myEvent.message);
								break;
		default:
								break;
		}
	evtrc = GetNextEvent(activMask+updateMask, &myEvent);
	}
}

void macinit(void)
{
short i;

			/* set-up general Macintosh environment */
MaxApplZone();				/* set-up for efficient storage use */
for (i=0; i < 4; i++) MoreMasters();
InitGraf(&qd.thePort);
FlushEvents(everyEvent, 0);
InitWindows();
InitFonts();
InitMenus();
InitDialogs(0L);
InitCursor();
TEInit();

			/* set-up menus */
for (i=0; i < NMENUS; i++) {
	myMenus[i] = GetMenu(256+i);
	InsertMenu(myMenus[i], 0);
	}
AddResMenu(myMenus[0], 'DRVR');
DrawMenuBar();

			/* calculate standard file dialog locations */
bigscreen = (((qd.screenBits.bounds.bottom - qd.screenBits.bounds.top) >= 480) &&
			 ((qd.screenBits.bounds.right - qd.screenBits.bounds.left) >= 640));

sfppoint.h = (qd.screenBits.bounds.right - qd.screenBits.bounds.left - 304)/2;
sfgpoint.h = (qd.screenBits.bounds.right - qd.screenBits.bounds.left - 348)/2;
if (bigscreen) {
	sfppoint.v = (qd.screenBits.bounds.bottom - qd.screenBits.bounds.top - 184)/3;
	sfgpoint.v = (qd.screenBits.bounds.bottom - qd.screenBits.bounds.top - 200)/3;
	}
else {
	sfppoint.v = (qd.screenBits.bounds.bottom - qd.screenBits.bounds.top - 184)/2;
	sfgpoint.v = (qd.screenBits.bounds.bottom - qd.screenBits.bounds.top - 200)/2;
	}

SetRect(&dragRect, 0, 24, qd.screenBits.bounds.right-4,
							qd.screenBits.bounds.bottom-4);
sizeRect.top = 25;
sizeRect.left = 50;
sizeRect.bottom = 192;
sizeRect.right = 395;

			/* center alerts */
ctralrt(257);
ctralrt(258);
ctralrt(261);
ctralrt(262);
ctralrt(263);
ctralrt(272);

			/* miscellaneous initializations */
sw_bgrnd = 0;		/* not in Switcher background */
mf_bgrnd = 0;		/* not in MultiFinder background */

statptr = 0;
netstat[0] = connstat[0] = prtstat[0] = 0;
statdlg(1, 0xff);		/* show status dialog */
}

void macend(void)
{
statdlg(2, 0);			/* remove status dialog */
if (new_settings()) if (savedlg()) write_settings();
}
 
void hndmac(void)
{
short code;
OSErr rc;
unsigned short h, w;
long l;
WindowPtr whichWindow;
unsigned char usenull;
static unsigned long limit = 0;
GrafPtr gp;

tcpevent();				/* TCP I/O which must happen often */
if (prtstate > 0)		/* check for no response from LPD server */
	if ((*Ticks) - prtstime > LPDLIMIT) {	/* allow 2 minutes */
		tcplgout();
		stoperr(lpdalrt);
		}

usenull = 1;			/* initially will do null processing */
if (!mf_bgrnd) {		/* don't do non-essential things to often */
						/* when running in the foreground */
	if (limit >= (*Ticks)) usenull = 0;
	else limit = (*Ticks) + 4;		/* set time for next null handling */
	}

					/* set sw_bgrnd to 2 if next GNE call will suspend us */
if (sw_bgrnd == 1) sw_bgrnd = 2;
if (mf_bgrnd) rc = WaitNextEvent(everyEvent, &myEvent, 4L, 0L);
		  else rc = GetNextEvent(everyEvent, &myEvent);

if ((rc == 0) && usenull)		/* FALSE from GNE */
	switch(myEvent.what) {
		case nullEvent:
				SystemTask();	/* run DAs, etc. */
				break;
		default:
				return;
		}
else if (rc != 0) switch(myEvent.what) {	/* TRUE from GNE */
		case mouseDown:
			code = FindWindow(myEvent.where, &whichWindow);
			switch (code) {
			case inMenuBar:
				menu_upd();
				docommand(MenuSelect(myEvent.where));
				break;
			case inSysWindow:
				SystemClick(&myEvent, whichWindow);
				break;
			case inDrag:
				if (whichWindow == FrontWindow())
					DragWindow(whichWindow, myEvent.where,
								&dragRect);
				else SelectWindow(whichWindow);
				break;
			case inGoAway:
				if (statptr && (whichWindow == statptr))
					if (TrackGoAway(whichWindow, myEvent.where))
						statdlg(2, 0);
				break;
			case inGrow:
				if (whichWindow == FrontWindow()) {
					GetPort(&gp);
					SetPort(whichWindow);
					l = GrowWindow(whichWindow, myEvent.where,
									&sizeRect);
					h = l >> 16;
					w = l & 0x0000ffffL;
					SizeWindow(whichWindow, w, h, true);
					if (statptr && (whichWindow == statptr)) {
						EraseRect(&(whichWindow->portRect));
						InvalRect(&(whichWindow->portRect));
						}
					SetPort(gp);
					}
				break;
			case inContent:
				if (whichWindow != FrontWindow())
					SelectWindow(whichWindow);
				break;
			case inZoomIn:
			case inZoomOut:
				if (TrackBox(whichWindow, myEvent.where, code))
					dozoom(whichWindow, code);
				break;

			default:
				break;
			}
			break;

		case mouseUp:
			break;

		case keyDown:
			if (myEvent.modifiers & cmdKey)
				docommand(MenuKey((short)(myEvent.message & 0xff)));
			break;
		case autoKey:
			break;
 
		case activateEvt:
			if (((struct GrafPort *)myEvent.message == statptr)
				&& statptr) statGrowIcon();
			break;
 
		case updateEvt:
			updevent((GrafPtr)myEvent.message);
			break;

		case app4Evt:		/* probably MF or Switcher */
			if ((myEvent.message & 0xff000000) != 0x01000000)
				break;	/* not MF/Switcher */
			else if (myEvent.message & 0x00000001) sw_resume();
					else sw_suspend();
			break;

		default:	break;
		}
}

void dozoom(wp, code)
WindowPtr wp;
short code;
{
GrafPtr gp;
						/* be sure this window can zoom */
if (((WindowPeek)wp)->dataHandle == 0) return;

GetPort(&gp);
SetPort((GrafPtr)wp);
EraseRect(&(wp->portRect));
ZoomWindow(wp, code, false);
SetPort(gp);
}

void updevent(msgptr)
GrafPtr msgptr;
{
GrafPtr gp;

GetPort(&gp);
SetPort(msgptr);
BeginUpdate(msgptr);
if (statptr && (msgptr == statptr)) {
	DrawDialog(statptr);
	statGrowIcon();
	}
EndUpdate(msgptr);
SetPort(gp);
}
 
void menu_upd(void)
{
WindowRecord * fw;
short fk;

fw = (WindowRecord *)FrontWindow();
fk = fw->windowKind;

if (pend_conn == 0) {
	EnableItem(myMenus[1], 1);
	EnableItem(myMenus[1], 4);
	EnableItem(myMenus[1], 5);
	}
else {
	DisableItem(myMenus[1], 1);
	DisableItem(myMenus[1], 4);
	DisableItem(myMenus[1], 5);
	}
if ((statptr && (statptr != FrontWindow())) ||
	(statptr == 0))
	EnableItem(myMenus[1], 7);
else DisableItem(myMenus[1], 7);
if (fk < 0) {
	EnableItem(myMenus[1], 9);
	}
else {
	DisableItem(myMenus[1], 9);
	}
CheckItem(myMenus[1], 11, done);

if (cs.vmflag)
	if ((*Ticks) - passtime > PASSLIMIT)
		memset(vmpass, 0, 9);
}
 
void docommand(mResult)
long mResult;
{
register short theItem, theMenu;
unsigned char name[40];
WindowRecord * fw;
short i;
 
theMenu = mResult >> 16;
theItem = mResult & 0xff;
switch(theMenu) {
	case appleMenu:
		if (theItem == 2) break;
		if (theItem == 1) {
			aboutdlg();
			break;
			}
		GetItem(myMenus[0], theItem, name);
		OpenDeskAcc(name);
		break;
	case fileMenu:
		switch (theItem) {
			case 1:		/* get settings */
					read_settings(0);
					break;
			case 2:		/* save settings */
					write_settings();
					break;
			case 4:		/* print file */
					printlist = 0;
					printit();
					break;
			case 5:		/* print list of files */
					printlist = 1;
					printit();
					break;
			case 7:		/* show status */
					if (statptr) SelectWindow(statptr);
					else statdlg(1, 0xff);
					break;
			case 9:		/* close */
					fw = (WindowRecord *)FrontWindow();
					i = fw->windowKind;
					if (i < 0) CloseDeskAcc(i);
					break;
			case 11:	/* quit */
					if (prtstate != 0)
						if (!quitdlg()) break;
					done ^= 1;
					break;
			default:
					break;
			}
		break;
	case editMenu:
		SystemEdit(theItem-1);
		break;
	case setMenu:
		switch (theItem) {
			case 1:
					orgdlg();
					break;
			case 2:
					destdlg(0);
					break;
			case 3:
					headdlg();
					break;
			case 4:
					fmtdlg();
					break;
			case 5:
					ctldlg();
					break;
			default:
					break;
			}
		break;
	default:
		break;
	}
	HiliteMenu(0);
}

void watchcurs(void)				/* set cursor to watch */
{
CursHandle curhand;

curhand = GetCursor(watchCursor); 	/* cursor -> watch during net init */
SetCursor(*curhand);
dfltcurs = 0;
}

void resetcurs(void)
{
if (dfltcurs) return;
InitCursor();						/* restore cursor */
dfltcurs = 1;
}

void getdflt(s, len, type, id)
unsigned char * s;
ResType type;
short len, id;
{
Handle h;
short ssize;

memset(s, 0, len);		/* initialize for comparisons */
h = GetResource(type, id);
if (h != 0) {
	ssize = ((unsigned char *)(*h))[0];
	if (ssize == 0) return;
	if (ssize > len - 1) ssize = len - 1;
	memcpy(s, ((unsigned char *)(*h))+1, ssize);
	}
}

short fixblank(s, size)
register unsigned char * s;
register short size;
{
register short i;
register short fixed;

fixed = i = 0;
while (s[i] && i < size) {
	if (s[i] == ' ') {
		s[i] = '_';
		fixed++;
		}
	i++;
	}
return(fixed);
}

void statGrowIcon(void)
{
GrafPtr psave;
Rect temprect;

GetPort(&psave);
SetPort(statptr);

temprect = statptr->portRect;
temprect.top = temprect.bottom-15;
temprect.left = temprect.right-15;
EraseRect(&temprect);
MoveTo(temprect.left, temprect.bottom);
LineTo(temprect.left, temprect.top);
LineTo(temprect.right, temprect.top);
if (((WindowPeek)statptr)->hilited) {
	temprect.left += 3;
	temprect.right = temprect.left + 7;
	temprect.top += 3;
	temprect.bottom = temprect.top + 7;
	FrameRect(&temprect);
	MoveTo(temprect.right, temprect.bottom-5);
	Line(3, 0);
	Line(0, 8);
	Line(-8, 0);
	Line(0, -3);
	}
SetPort(psave);
}
