//	Copyright:	 1992 by Apple Computer, Inc., all rights reserved.

#include "mtb.h"

void		CreateMyVideoTrack (Movie theMovie)
{
	Track 				theTrack;
	Media				theMedia;
	OSErr 				err = noErr;
	Rect 				trackFrame = {0,0,100,320};

	theTrack = NewMovieTrack (theMovie, 
									FixRatio(trackFrame.right,1),
									FixRatio(trackFrame.bottom,1), 
									kNoVolume);
	CheckError( GetMoviesError(), "\pNewMovieTrack" );
	
	theMedia = NewTrackMedia (theTrack, VideoMediaType,
									600, 	// Video Time Scale
									nil, 0);
	CheckError( GetMoviesError(), "\pNewTrackMedia" );
	
	err = BeginMediaEdits (theMedia);
	CheckError( err, "\pBeginMediaEdits" );

	AddVideoSamplesToMedia (theMedia, &trackFrame);
	
	err = EndMediaEdits (theMedia);
	CheckError( err, "\pEndMediaEdits" );
	
	err = InsertMediaIntoTrack (theTrack, 
								0,	// track start time
								0,	// media start time
								GetMediaDuration (theMedia),
								kFix1);
	CheckError( err, "\pInsertMediaIntoTrack" );
}
